'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _LoadingIndicatorJsx = require('./LoadingIndicator.jsx');

var _LoadingIndicatorJsx2 = _interopRequireDefault(_LoadingIndicatorJsx);

var _haveAllPropertiesLoaded = require('./haveAllPropertiesLoaded');

var _haveAllPropertiesLoaded2 = _interopRequireDefault(_haveAllPropertiesLoaded);

/**
 * Decorates a component and displays a loading indicator until component dependencies have pre-loaded.
 *
 * Components can make use of a special :isLoading property to explicitly control creation.
 * If :isLoading is false the decorated component will not be created (even if all other properties are defined).
 * If :isLoading is true the decorated component will be created (even if all other properties are undefined).
 * If there is no :isLoading property then the component will be created only once all properties are defined.
 *
 * Components can also specify a value for :isVisible to control whether anything (including the loading indicator) is shown.
 * This property can be useful for deferred components such as modal dialogs.
 * A loading graphic should not be shown for such components unless they're actually supposed to be visible.
 *
 * Usage example:
 * <WaitToRender
 *   wrappedComponent={SomeComponentClass}
 *   someRequiredProperty={...}
 *   anotherRequiredProperty={...} />
 */

var WaitToRender = (function (_Component) {
  _inherits(WaitToRender, _Component);

  function WaitToRender() {
    _classCallCheck(this, WaitToRender);

    _get(Object.getPrototypeOf(WaitToRender.prototype), 'constructor', this).apply(this, arguments);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
  }

  _createClass(WaitToRender, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var isVisible = _props.isVisible;
      var loadingIndicator = _props.loadingIndicator;

      if (isVisible === false) {
        return null;
      } else if (!(0, _haveAllPropertiesLoaded2['default'])(this.props)) {
        return loadingIndicator;
      } else {
        var _props2 = this.props;
        var WrappedComponent = _props2.wrappedComponent;

        var props = _objectWithoutProperties(_props2, ['wrappedComponent']);

        return _react2['default'].createElement(WrappedComponent, props);
      }
    }
  }], [{
    key: 'propTypes',
    value: {
      /** Main React component for page. */
      wrappedComponent: _react.PropTypes.any.isRequired,

      /** Allows finer-grained control over when decorated component is rendered. */
      isLoading: _react.PropTypes.bool,

      /** Allows finer-grained control over when loading indicator or component should be shown. */
      isVisible: _react.PropTypes.bool,

      /** Optional loading indicator (overrides default). */
      loadingIndicator: _react.PropTypes.node.isRequired
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      loadingIndicator: _react2['default'].createElement(_LoadingIndicatorJsx2['default'], null)
    },
    enumerable: true
  }]);

  return WaitToRender;
})(_react.Component);

exports['default'] = WaitToRender;
module.exports = exports['default'];