'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports['default'] = WaitToRenderDecorator;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _LoadingIndicatorJsx = require('./LoadingIndicator.jsx');

var _LoadingIndicatorJsx2 = _interopRequireDefault(_LoadingIndicatorJsx);

var _haveAllPropertiesLoaded = require('./haveAllPropertiesLoaded');

var _haveAllPropertiesLoaded2 = _interopRequireDefault(_haveAllPropertiesLoaded);

/**
 * Decorates a component class so that instances of it will display a loading indicator until dependencies have pre-loaded.
 * See <WaitToRender> documentation for more information on how the decorated component works.
 */

function WaitToRenderDecorator(WrappedComponent) {
  var componentDisplayName = WrappedComponent.displayName || WrappedComponent.name || 'Component';

  return (function (_Component) {
    _inherits(DecoratedWaitToRenderDecorator, _Component);

    function DecoratedWaitToRenderDecorator() {
      _classCallCheck(this, DecoratedWaitToRenderDecorator);

      _get(Object.getPrototypeOf(DecoratedWaitToRenderDecorator.prototype), 'constructor', this).apply(this, arguments);

      this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
    }

    _createClass(DecoratedWaitToRenderDecorator, [{
      key: 'render',
      value: function render() {
        var isVisible = this.props.isVisible;

        var LoadingIndicator = WrappedComponent.loadingIndicator || _react2['default'].createElement(_LoadingIndicatorJsx2['default'], null);

        if (isVisible === false) {
          return null;
        } else if (!(0, _haveAllPropertiesLoaded2['default'])(this.props)) {
          return LoadingIndicator;
        } else {
          return _react2['default'].createElement(WrappedComponent, this.props);
        }
      }
    }], [{
      key: 'displayName',

      // Used by React devtools when generating DOM tree
      value: 'Decorated(' + componentDisplayName + ')',

      // Expose decorated class for testing convenience
      enumerable: true
    }, {
      key: 'WrappedComponent',
      value: WrappedComponent,
      enumerable: true
    }]);

    return DecoratedWaitToRenderDecorator;
  })(_react.Component);
}

module.exports = exports['default'];